void WriteMemory(_int32 vaddr, _int8 value, HWND hWnd)
{
	
	_int32 oldvaddr=vaddr;
	int mem;
        if((vaddr>=0x80000000) && (vaddr<=0x9FFFFFFF)) vaddr=vaddr-0x80000000;
        if((vaddr>=0xA0000000) && (vaddr<=0xBFFFFFFF)) vaddr=vaddr-0xA0000000;
        if((vaddr>=0) && (vaddr<=0x003FFFFF)) mem=1;
        if((vaddr>=0x03F00000) && (vaddr<=0x03F00027)) mem=2;
        if((vaddr>=0x04000000) && (vaddr<=0x04000FFF)) mem=12;
        if((vaddr>=0x04001000) && (vaddr<=0x04001FFF)) mem=13;
        if((vaddr>=0x04040000) && (vaddr<=0x0404001F)) mem=14;
        if((vaddr>=0x04080000) && (vaddr<=0x04080007)) mem=22;
        if((vaddr>=0x04100000) && (vaddr<=0x0410001F)) mem=24;
        if((vaddr>=0x04200000) && (vaddr<=0x0420000F)) mem=32;
        if((vaddr>=0x04300000) && (vaddr<=0x04300037)) mem=36;
        if((vaddr>=0x04400000) && (vaddr<=0x04400037)) mem=40;
        if((vaddr>=0x04500000) && (vaddr<=0x04500017)) mem=54;
        if((vaddr>=0x04600000) && (vaddr<=0x04600033)) mem=60;
        if((vaddr>=0x04700000) && (vaddr<=0x0470001F)) mem=73;
        if((vaddr>=0x04800000) && (vaddr<=0x0480001B)) mem=81;
 switch (mem)
 {
 case 1:
 	 RAM[vaddr]=value;
	 break;
 case 2:
	 RDRAMreg[vaddr-0x03F00000]=value;
	 break;
  case 12:
	 SP_DMEM[vaddr-0x04000000]=value;
	 break;
 case 13:
	 SP_IMEM[vaddr-0x04001000]=value;
	 break;
 case 14:
	 SP_MEMreg[vaddr-0x04040000]=value;
	 break;
 case 22:
	 SP_MEMreg[vaddr-0x04080000]=value;
	 break;
 case 24:
	 DPreg[vaddr-0x04100000]=value;
	 break;
 
 case 32:
	 DPSreg[vaddr-0x04200000]=value;
	 break;
 
 case 36:
	 MIreg[vaddr-0x04300000]=value;
	 break;
 
 case 40:
	 VIreg[vaddr-0x04400000]=value;
	 break;
 
 case 54:
	 AIreg[vaddr-0x04500000]=value;
	 break;
 
 case 60:
	 PIreg[vaddr-0x04600000]=value;
	 break;
 
 case 73:
	 RIreg[vaddr-0x04700000]=value;
	 break;
 
 case 81:
	 SIreg[vaddr-0x04800000]=value;
	 break;
default:
	 sprintf(text,"Unhandled memory address: %x",(vaddr));
	 MessageBox(hWnd,text, "Memory Error: Write",MB_OK);
	 break;
 }
 vaddr=oldvaddr;
}

_int8 ReadMemory(unsigned _int32 vaddr, HWND hWnd)
{
	_int8 something;
	unsigned _int32 oldvaddr=vaddr;
	int mem;
        if((vaddr>=0x80000000) && (vaddr<=0x9FFFFFFF)) vaddr=vaddr-0x80000000;
        if((vaddr>=0xA0000000) && (vaddr<=0xBFFFFFFF)) vaddr=vaddr-0xA0000000;
        if((vaddr>=0) && (vaddr<=0x003FFFFF)) return (_int8)RAM[vaddr];
        if((vaddr>=0x03F00000) && (vaddr<=0x03F00027)) return (_int8)RDRAMreg[vaddr-0x03F00000];
        if((vaddr>=0x04000000) && (vaddr<=0x04000FFF)) return (_int8)SP_DMEM[vaddr-0x04000000];
        if((vaddr>=0x04001000) && (vaddr<=0x04001FFF)) return (_int8)SP_IMEM[vaddr-0x04001000];
        if((vaddr>=0x04040000) && (vaddr<=0x0404001F)) return (_int8)SP_MEMreg[vaddr-0x04040000];
        if((vaddr>=0x04080000) && (vaddr<=0x04080007)) return (_int8)SP_MEMreg[vaddr-0x04080000];
        if((vaddr>=0x04100000) && (vaddr<=0x0410001F)) return (_int8)DPreg[vaddr-0x04100000];
        if((vaddr>=0x04200000) && (vaddr<=0x0420000F)) return (_int8)DPSreg[vaddr-0x04200000];
        if((vaddr>=0x04300000) && (vaddr<=0x04300037)) return (_int8)MIreg[vaddr-0x04300000];
        if((vaddr>=0x04400000) && (vaddr<=0x04400037)) return (_int8)VIreg[vaddr-0x04400000];
        if((vaddr>=0x04500000) && (vaddr<=0x04500017)) return (_int8)AIreg[vaddr-0x04500000];
        if((vaddr>=0x04600000) && (vaddr<=0x04600033)) return (_int8)PIreg[vaddr-0x04600000];
        if((vaddr>=0x04700000) && (vaddr<=0x0470001F)) return (_int8)RIreg[vaddr-0x04700000];
        if((vaddr>=0x04800000) && (vaddr<=0x0480001B)) return (_int8)SIreg[vaddr-0x04800000];
        if((vaddr>=0x10000000) && (vaddr<=0x1FBFFFFF)) 
		{
		 if(vaddr<=(OldPC+64))
		 {
		 if(BS && ((OC[0] != 'R') && (OC[6] != 'g')))
		 {
		 if(!(z%2)) 
		 {
			SetFilePointer(RomHandle,vaddr-OldPC+64+1,0,FILE_BEGIN);
		 }
		 else
		 {
			SetFilePointer(RomHandle,vaddr-OldPC+64-1,0,FILE_BEGIN);
		 }
		 }
		else
		{
		SetFilePointer(RomHandle,vaddr-OldPC+64,0,FILE_BEGIN);
		}
		ReadFile(RomHandle,four,1,&dwRead,NULL);
		something=four[0];
		return (_int8)something;
	 }
	 else
	 {
		if(BS)
		{
		if(!(z%2)) 
		{
			SetFilePointer(RomHandle,vaddr-OldPC+1,0,FILE_BEGIN);
		}
		else
		{
			SetFilePointer(RomHandle,vaddr-OldPC-1,0,FILE_BEGIN);
		}
	}
	else
	{
		SetFilePointer(RomHandle,vaddr-OldPC,0,FILE_BEGIN);
	}
	
		 ReadFile(RomHandle,four,1,&dwRead,NULL);
		 something=four[0];
		 return (_int8)something;
	 }
	 
}
	 sprintf(text,"Unhandled memory address: %x\nStopped on opcode number: %d\nPC: %x\nOpcode:",(oldvaddr),CP0[9], PC);
	 strcat(text, OC);
	 MessageBox(hWnd,text, "Memory Error: Read",MB_OK);
	 N64isRunning=0;
	 return 0;
	 vaddr=oldvaddr;
}
